package com.gic.haoban.manage.service.service.hm.impl;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.UniqueIdUtils;
import com.gic.haoban.manage.service.dao.mapper.hm.HmQrcodeTempMapper;
import com.gic.haoban.manage.service.entity.hm.TabHmQrcodeTemp;
import com.gic.haoban.manage.service.pojo.qo.HmQrcodeTempQO;
import com.gic.haoban.manage.service.service.hm.HmQrcodeTempService;

@Service
public class HmQrcodeTempServiceImpl implements HmQrcodeTempService {

    @Autowired
    private HmQrcodeTempMapper hmQrcodeTempMapper;

    @Override
    public void save(HmQrcodeTempQO qo) {
        TabHmQrcodeTemp entity = EntityUtil.changeEntityByJSON(TabHmQrcodeTemp.class, qo);
        entity.setCreateTime(new Date());
        entity.setUpdateTime(new Date());
        entity.setStatusFlag(1);
        entity.setId(UniqueIdUtils.uniqueLong());
        this.hmQrcodeTempMapper.insert(entity);
    }

    @Override
    public void deleteQrcode(String relationId) {
        this.hmQrcodeTempMapper.deleteByRelationId(relationId);
    }

    @Override
    public void deleteQrcodeById(Long id) {
        this.hmQrcodeTempMapper.deleteByPrimaryKey(id);
    }

}
