package com.gic.haoban.manage.service.service.out.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.enterprise.api.dto.EnterpriseDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.dto.qdto.ClerkSyncQDTO;
import com.gic.haoban.manage.api.enums.AuditType;
import com.gic.haoban.manage.api.enums.BindTypeEnum;
import com.gic.haoban.manage.api.enums.ChannelCodeEnum;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.service.AuditApiService;
import com.gic.haoban.manage.api.service.StaffClerkRelationApiService;
import com.gic.haoban.manage.api.service.hm.HmQrcodeApiService;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanStaffClerkRelationMapper;
import com.gic.haoban.manage.service.entity.MemberClerkChatConfig;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkBindLog;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkRelation;
import com.gic.haoban.manage.service.service.*;
import com.gic.haoban.manage.service.task.RouterConstant;
import com.gic.haoban.task.api.dto.MqMessageQo;
import com.gic.wechat.api.dto.qywx.welcome.QywxExternalcontactDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StaffClerkRelationApiServiceImpl implements StaffClerkRelationApiService {

    private static final Logger logger = LoggerFactory.getLogger(StaffClerkRelationApiServiceImpl.class);

    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private ClerkService clerkService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private TabHaobanStaffClerkRelationMapper tabHaobanStaffClerkRelationMapper;
    @Autowired
    private AuditApiService auditApiService;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
    @Autowired
    private StaffClerkBindLogService staffClerkBindLogService;
    @Autowired
    private StaffService staffService;
    @Autowired
    private ExternalClerkRelatedService externalClerkRelatedService;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private SecretSettingService secretSettingService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;
    @Autowired
    private HmQrcodeApiService hmQrcodeApiService;

    @Override
    public void bindLogMq(String params) {
        logger.info("绑定日志mq:{}", params);
        StaffClerkBindLogInfoDTO infoDTO = JSONObject.parseObject(params, StaffClerkBindLogInfoDTO.class);
        if (null == infoDTO) {
            logger.info("数据不存在");
            return;
        }
        TabHaobanStaffClerkRelation clerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(infoDTO.getRelationId());
        if (null == clerkRelation) {
            logger.info("不存在绑定数据");
            return;
        }
        ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkRelation.getClerkId());
        String phoneNumber = "";
        String clerkName = null;
        if (null != clerkDTO) {
            phoneNumber = clerkDTO.getPhoneNumber();
            clerkName = clerkDTO.getClerkName() ;
        }
        String operClerkId = infoDTO.getOptStaffId() ;
        clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkRelation.getClerkId());
        String operName = null ;
        if (null != clerkDTO) {
            operName = clerkDTO.getClerkName() ;
        }
        TabHaobanStaffClerkBindLog enity = new TabHaobanStaffClerkBindLog();
        enity.setClerkId(clerkRelation.getClerkId());
        enity.setChannelCode(infoDTO.getChannelCode());
        enity.setClerkCode(clerkRelation.getClerkCode());
        enity.setCreateTime(new Date());
        enity.setEnterpriseId(clerkRelation.getEnterpriseId());
        enity.setOptStaffId(operClerkId);
        enity.setOperName(operName);
        enity.setOptType(infoDTO.getOptType());
        enity.setStatusFlag(1);
        enity.setStaffId(clerkRelation.getStaffId());
        enity.setWxEnterpriseId(clerkRelation.getWxEnterpriseId());
        enity.setRelationId(infoDTO.getRelationId());
        enity.setClerkPhone(phoneNumber);
        enity.setUpdateTime(new Date());
        enity.setClerkName(clerkName);
        staffClerkBindLogService.insert(enity);
    }

    @Override
    public List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList) {
        return staffClerkRelationService.listBindCode(enterpriseId, clerkCodeList);
    }

    @Override
    public List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId) {
        return staffClerkRelationService.listBindCodeByStaffId(enterpriseIdList, staffId);
    }

    @Override
    public List<StaffClerkInfoDTO> listBindDetailByStaffId(String staffId) {
        List<StaffClerkRelationDTO> list = staffClerkRelationService.listBindCodeByStaffId(null, staffId);
        if (CollectionUtils.isEmpty(list)) {
            return null;
        }
        List<StaffClerkInfoDTO> infoDTOS = EntityUtil.changeEntityListByJSON(StaffClerkInfoDTO.class, list);
        Map<String, String> nameMap = new HashMap<>();
        infoDTOS.forEach(infoDTO -> {
            //企业
            if (!nameMap.containsKey(infoDTO.getEnterpriseId())) {
                EnterpriseDTO enterpriseDTO = enterpriseService.getEnterpriseById(infoDTO.getEnterpriseId());
                if (null != enterpriseDTO) {
                    nameMap.put(infoDTO.getEnterpriseId(), enterpriseDTO.getEnterpriseName() + "_" + enterpriseDTO.getBrandName());
                } else {
                    nameMap.put(infoDTO.getEnterpriseId(), "未知商户");
                }
            }
            //门店店员名称
            if (!nameMap.containsKey(infoDTO.getClerkId())) {
                ClerkDTO clerkDTO = clerkService.getClerkByClerkId(infoDTO.getClerkId());
                if (null != clerkDTO) {
                    nameMap.put(infoDTO.getClerkId(), clerkDTO.getClerkName());
                    nameMap.put(infoDTO.getStoreId(), clerkDTO.getStoreName());
                    infoDTO.setClerkPhoneNumber(clerkDTO.getPhoneNumber());
                } else {
                    nameMap.put(infoDTO.getClerkId(), "未知店员");
                }
            }

            //门店店员名称
            if (!nameMap.containsKey(infoDTO.getStoreId())) {
                StoreDTO storeDTO = storeService.getStore(infoDTO.getStoreId());
                if (null != storeDTO) {
                    nameMap.put(infoDTO.getStoreId(), storeDTO.getStoreName());
                } else {
                    nameMap.put(infoDTO.getStoreId(), "未知门店");
                }
            }

            infoDTO.setClerkName(nameMap.get(infoDTO.getClerkId()));
            infoDTO.setStoreName(nameMap.get(infoDTO.getStoreId()));
            if ((nameMap.get(infoDTO.getEnterpriseId())) != null) {
                String enterpriseAndBrandName = nameMap.get(infoDTO.getEnterpriseId());
                String[] split = enterpriseAndBrandName.split("_");
                infoDTO.setEnterpriseName(split[0]);
                if (split[1] != null) {
                    infoDTO.setBrandName(split[1]);
                }
            }
        });
        return infoDTOS;
    }

    @Override
    public ServiceResponse bindStaffClerk(StaffClerkRelationDTO staffClerkRelationDTO, String optStaffId, int chanelCode) {
        logger.info("绑定clerk:{}", JSONObject.toJSONString(staffClerkRelationDTO));
        ServiceResponse<Object> response = new ServiceResponse<>();
        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getBindByClerkId(staffClerkRelationDTO.getClerkId(), staffClerkRelationDTO.getWxEnterpriseId());
        if (null != relationDTO) {
            response.setCode(2);
            response.setMessage("已经被绑定，不能绑定");
            return response;
        }
        AuditDTO auditDTO = auditApiService.findByBindRelatedIdAndAuditType(staffClerkRelationDTO.getClerkId(), AuditType.CLERK_BIND.getCode());
        if (null != auditDTO) {
            response.setCode(4);
            response.setMessage("该导购已经被被申请绑定，请审核处理后再绑定");
            return response;
        }
        List<AuditDTO> list = auditApiService.listByStoreId(staffClerkRelationDTO.getStoreId());
        if (CollectionUtils.isNotEmpty(list)) {
            Set<String> staffIds = list.stream().map(AuditDTO::getCommitStaffId).collect(Collectors.toSet());
            if (staffIds.contains(staffClerkRelationDTO.getStaffId())) {
                response.setCode(5);
                response.setMessage("该成员已经已经在该门店下申请了绑定，请审核处理后再绑定");
                return response;
            }
        }
        StaffClerkRelationDTO storeHasBind = staffClerkRelationService.getOneBindByStoreId(staffClerkRelationDTO.getStaffId(), staffClerkRelationDTO.getStoreId());
        if (storeHasBind != null) {
            response.setCode(3);
            response.setMessage("该导购已在该门店下有其它成员绑定");
            return response;
        }

        String relationId = staffClerkRelationService.bind(staffClerkRelationDTO, optStaffId, chanelCode);
        response.setResult(relationId);
        return response;
    }

    @Override
    public StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId) {
        return staffClerkRelationService.getByCodeAndEnterpriseId(clerkCode, enterpriseId);
    }


    @Override
    public void delByStoreIdAndCode(String storeId, String clerkCode) {
        TabHaobanStaffClerkRelation staffClerkRelation = tabHaobanStaffClerkRelationMapper.getByCodeAndStoreId(clerkCode, storeId);
        //删除绑定关系
        tabHaobanStaffClerkRelationMapper.delByStoreIdAndCode(storeId, clerkCode);
        //删除主门店
        delSetMainStore(staffClerkRelation);
    }

    @Override
    public List<StaffClerkRelationDTO> listByClerkIds(List<String> clerkIds) {
        if (CollectionUtil.isEmpty(clerkIds)) {
            return Collections.EMPTY_LIST;
        }
        return tabHaobanStaffClerkRelationMapper.listByClerkIds(clerkIds);
    }

    @Override
    public List<StaffClerkRelationDTO> listByStoreId(String storeId) {
        List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByStoreId(storeId);
        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<StaffClerkRelationDTO>();
        }
        List<StaffClerkRelationDTO> result = EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
        return result;
    }

    @Override
    public boolean unbindByStaffAndClerkId(String staffId, String clerkId) {
        return staffClerkRelationService.delBind(clerkId, staffId, ChannelCodeEnum.ADMIN_UNBIND.getCode());
    }

    @Override
    public StaffClerkRelationDTO getOneByClerkId(String clerkId) {
        TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
        StaffClerkRelationDTO result = EntityUtil.changeEntityByJSON(StaffClerkRelationDTO.class, tab);
        return result;
    }

    @Override
    public StaffClerkRelationDTO getByClerkId(String clerkId) {
        StaffClerkRelationDTO staffRelation = staffClerkRelationService.getByClerkId(clerkId);
        return staffRelation;
    }

    @Override
    public StaffClerkRelationDTO getOneByStoreIdAndStaffId(String storeId,
                                                           String staffId) {
        TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByStoreIdAndStaffId(storeId, staffId);
        if (tab == null) {
            return null;
        }
        return EntityUtil.changeEntity(StaffClerkRelationDTO.class, tab);
    }

    @Override
    public void delAndInsert(StaffClerkRelationDTO staffClerkRelation, String optStaffId, int chanelCode) {
        if (StringUtils.isNotBlank(staffClerkRelation.getStaffClerkRelationId())) {
            TabHaobanStaffClerkRelation oldStaffClerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
            tabHaobanStaffClerkRelationMapper.delByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
            staffClerkBindLogService.pushToMq(oldStaffClerkRelation.getStaffId(), optStaffId, BindTypeEnum.UNBIND.getVal(), chanelCode, staffClerkRelation.getStaffClerkRelationId());
            clerkMainStoreRelatedService.delMainStore(oldStaffClerkRelation.getStaffId(), oldStaffClerkRelation.getStoreId(), oldStaffClerkRelation.getWxEnterpriseId());
        }
        String relationId = staffClerkRelationService.insert(staffClerkRelation);
        staffClerkBindLogService.pushToMq(staffClerkRelation.getStaffId(), optStaffId, BindTypeEnum.BIND.getVal(), chanelCode, relationId);
        //设置主门店
        clerkMainStoreRelatedService.getMainStoreByStaffId(staffClerkRelation.getStaffId(), staffClerkRelation.getWxEnterpriseId());
    }

    @Override
    public void delByClerkId(String clerkId) {
        TabHaobanStaffClerkRelation staffClerkRelation = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
        tabHaobanStaffClerkRelationMapper.delByClerkId(clerkId);
        delSetMainStore(staffClerkRelation);
    }

    @Override
    public List<StaffClerkRelationDTO> listByEnterpriseIdAndWxUserId(String enterpriseId, String wxUserId) {
        List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByEnterpriseIdAndWxUserId(enterpriseId, wxUserId);
        return EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
    }

    @Override
    public Page<StaffClerkBindLogDetailDTO> pageStaffClerkBindLog(String wxEnterpriseId, String search, String enterpriseId, int optType, BasePageInfo pageInfo) {
        Page<StaffClerkBindLogDetailDTO> retList = staffClerkBindLogService.pageBindLog(wxEnterpriseId, enterpriseId, optType, search, pageInfo);
        if (CollectionUtils.isNotEmpty(retList.getResult())) {
            retList.getResult().forEach(item -> {
                TabHaobanStaff haobanStaff = staffService.selectById(item.getStaffId());
                if (null != haobanStaff) {
                    item.setStaffName(haobanStaff.getStaffName());
                    item.setWxUserId(haobanStaff.getWxUserId());
                } else {
                    item.setStaffName("未知成员");
                }
                if ("-1".equals(item.getOptStaffId())) {
                    item.setOptStaffName("系统");
                }else {
                    item.setOptStaffName(item.getOperName());
                }
                if(StringUtils.isBlank(item.getOptStaffName())) {
                    item.setOptStaffName("未知成员");
                }
                if(StringUtils.isBlank(item.getClerkName())) {
                    ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(item.getClerkId());
                    if (null != clerkDTO) {
                        item.setClerkName(clerkDTO.getClerkName());
                    }
                }
                item.setClerkPhoneNumber(item.getClerkPhone());
            });
        }
        return retList;
    }

    @Override
    public Page<StaffClerkBindLogDetailDTO> pageStaffClerkUnBindLog(String wxEnterpriseId, String clerkId, String enterpriseId, int optType, BasePageInfo pageInfo) {
        if (wxEnterpriseId == null) {
            logger.info("没有关联企业");
            return null;
        }
        Page<StaffClerkBindLogDetailDTO> retList = staffClerkBindLogService.pageUnBindLog(wxEnterpriseId, clerkId, enterpriseId, optType, pageInfo);
        if (CollectionUtils.isNotEmpty(retList.getResult())) {
            retList.getResult().forEach(item -> {
                TabHaobanStaff haobanStaff = staffService.selectById(item.getStaffId());
                if (null != haobanStaff) {
                    item.setStaffName(haobanStaff.getStaffName());
                    item.setWxUserId(haobanStaff.getWxUserId());
                } else {
                    item.setStaffName("未知成员");
                }
                if ("-1".equals(item.getOptStaffId())) {
                    item.setOptStaffName("系统");
                }else {
                    item.setOptStaffName(item.getOperName());
                }
                if(StringUtils.isBlank(item.getOptStaffName())) {
                    item.setOptStaffName("未知成员");
                }
                if(StringUtils.isBlank(item.getClerkName())) {
                    ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(item.getClerkId());
                    if (null != clerkDTO) {
                        item.setClerkName(clerkDTO.getClerkName());
                    }
                }
                item.setClerkPhoneNumber(item.getClerkPhone());
            });
        }
        return retList;
    }

    @Override
    public void pushToBindLog(String staffId, String optStaffId, int optType, int channelCode, String relationId) {
        staffClerkBindLogService.pushToMq(staffId, optStaffId, optType, channelCode, relationId);
    }

    private void delSetMainStore(TabHaobanStaffClerkRelation staffClerkRelation) {
        if (staffClerkRelation == null) {
            logger.info("staffClerkRelation为空");
            return;
        }
        String staffId = staffClerkRelation.getStaffId();
        String wxEnterpriseId = staffClerkRelation.getWxEnterpriseId();
        String clerkId = staffClerkRelation.getClerkId();
        externalClerkRelatedService.delByClerkIdAndStaffId(clerkId, staffId);
        //删除主门店
        clerkMainStoreRelatedService.delMainStore(staffId, staffClerkRelation.getStoreId(), wxEnterpriseId);
        //废弃活码
        hmQrcodeApiService.delByClerkId(clerkId,staffClerkRelation.getEnterpriseId());
    }

    @Override
    public ServiceResponse<String> getClerkMemberChatConfig(String clerkId) {
        ServiceResponse response = new ServiceResponse();
        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getByClerkId(clerkId);
        if (null == relationDTO) {
            logger.info("导购没有关联企业微信：{}", clerkId);
            response.setCode(2);
            response.setMessage("导购没有关联企业微信");
            return response;
        }

        MemberClerkChatConfig chatConfig = staffClerkRelationService.getChatConfig(relationDTO.getStaffId(), "-1");
        if (chatConfig != null) {
            response.setResult(chatConfig.getConfigId());
            return response;
        }

        QywxExternalcontactDTO send = new QywxExternalcontactDTO();
        send.setType(1);
        send.setScene(1);
        send.setRemark("导购:" + relationDTO.getClerkCode());
        List<String> userIds = new ArrayList<>();
        userIds.add(relationDTO.getWxUserId());
        send.setUser(userIds);


        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(relationDTO.getWxEnterpriseId(), SecretTypeEnum.HAOBAN_HELP.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            logger.info("没有配置secret:{}", relationDTO.getWxEnterpriseId());
            response.setCode(3);
            response.setMessage("企业微信配置异常");
            return response;
        }
        WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(relationDTO.getWxEnterpriseId());
        String configId = qywxUserApiService.getSelfExternalcontactByUserId(enterpriseDTO.getCorpid(), secretSetting.getSecretVal(), send);
        logger.info("configId:{}", configId);
        if (StringUtils.isBlank(configId)) {
            logger.info("staff:{}", configId, JSONObject.toJSONString(relationDTO));
            response.setCode(4);
            response.setMessage("创建config失败");
            return response;
        }
        MemberClerkChatConfig clerkChatConfig = new MemberClerkChatConfig();
        clerkChatConfig.setConfigId(configId);
        clerkChatConfig.setEnterpriseId(relationDTO.getEnterpriseId());
        clerkChatConfig.setMemberId("-1");
        clerkChatConfig.setStaffId(relationDTO.getStaffId());
        staffClerkRelationService.saveChatConfig(clerkChatConfig);

        response.setResult(clerkChatConfig.getConfigId());
        return response;
    }

    @Override
    public Page<StaffClerkRelationDTO> pageByWxEnterpriseId(String wxEnterpriseId, BasePageInfo pageInfo) {
        return staffClerkRelationService.pageByWxEnterpriseId(wxEnterpriseId, pageInfo);
    }

    @Override
    public List<StaffClerkRelationDTO> listAll() {
        return staffClerkRelationService.listAll();
    }

    @Override
    public List<StaffClerkRelationDTO> listByStaffId(String wxEnterpriseId,String staffId) {
        return staffClerkRelationService.listByStaffId(wxEnterpriseId,staffId);
    }

    @Override
    public List<StaffClerkRelationDTO> listClerkIdConcatFlagByClerkIds(List<String> clerkIds, String wxEnterpriseId) {
        return staffClerkRelationService.listClerkIdConcatFlagByClerkIds(clerkIds, wxEnterpriseId);
    }

    @Override
    public void clerkStoreMoveDel(String param) {
        logger.info("导购转移删除修改：{}",param);
        if (StringUtils.isBlank(param)) {
            logger.error("参数为空");
            return;
        }
        ClerkSyncQDTO clerkSyncQDTO = JSON.parseObject(param, ClerkSyncQDTO.class);
        Integer type = clerkSyncQDTO.getType();
        String clerkId = clerkSyncQDTO.getClerkId();
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId);
        if (clerkDTO == null) {
            logger.error("导购为空");
            return;
        }

        if (type == 1) {
            //导购删除解绑
            if (!clerkDTO.getStatus().equals(1)) {
                //解绑
                staffClerkRelationService.delBind(clerkId, "-1", ChannelCodeEnum.SYNC_UNBIND.getCode());
            }
        } else if (type == 2) {
            //门店转移、重新绑定
            StaffClerkRelationDTO relationDTO = staffClerkRelationService.getOneBindCodeNoStatus(clerkDTO.getEnterpriseId(), clerkDTO.getClerkCode());
            moveOrAddClerk(clerkSyncQDTO,relationDTO);
        } else if (type == 3) {
            //店长任务重新分配
            Integer clerkType = clerkDTO.getClerkType();
            if (clerkType != null && clerkType == 1) {
                //发消息处理新增店长，任务重新分配问题
                try {
                    logger.info("待分配任务重分配======>{}", clerkId);
                    MqMessageQo mqMessageQo = new MqMessageQo();
                    //任务分配给店长
                    mqMessageQo.setType(MqMessageQo.DISTRIBUTE_TASK);
                    mqMessageQo.setData(clerkId);
                    String s = JSONObject.toJSONString(mqMessageQo);
                    GICMQClientUtil.getClientInstance().sendCommonMessage(RouterConstant.ROUTERTYPE, s,
                            "com.gic.haoban.task.api.service.MqAsynApiService", "run");
                } catch (Exception e) {
                    logger.error("任务重新分配问题发送消息队列出错",e);
                }
            }
        }
    }


    private void moveOrAddClerk(ClerkSyncQDTO clerkSyncQDTO, StaffClerkRelationDTO relationDTO) {
        if (null == relationDTO) {
            logger.info("没有关联导购，不需要新增");
            return;
        }
        //正常的时候
        staffClerkRelationService.delBind(relationDTO.getClerkId(), "-1", ChannelCodeEnum.SYNC_UNBIND.getCode());
        relationDTO.setClerkId(clerkSyncQDTO.getClerkId());
        relationDTO.setStoreId(clerkSyncQDTO.getStoreId());
        ServiceResponse response = bindStaffClerk(relationDTO, "-1", ChannelCodeEnum.SYNC_BIND.getCode());
        logger.info("绑定结果正常：{}，{}", JSONObject.toJSONString(response), relationDTO.getClerkId());
    }
}
